import * as lsp from 'vscode-languageserver';
export declare function applyEdits(before: string, edits: lsp.TextEdit[]): string;
export interface Line {
    text: string;
}
export declare class LspDocument {
    uri: string;
    text: string;
    version: number;
    lastAccessed: number;
    constructor(doc: lsp.TextDocumentItem);
    private readonly lines;
    lineAt(line: number): Line;
    markAccessed(): void;
    getPosition(offset: number): lsp.Position;
    offsetAt(position: lsp.Position): number;
    apply(contentChanges: lsp.TextDocumentContentChangeEvent[], version: number): void;
    applyEdits(edits: lsp.TextEdit[]): void;
    save(): Promise<void>;
}
