"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai = require("chai");
const document_1 = require("./document");
describe('document', () => {
    it('getPosition', () => {
        const doc = new document_1.LspDocument({
            text: `Mdfsdf
dfsdfsd
dfdsf`, uri: 'foo', version: 0, languageId: 'FOO'
        });
        chai.assert.equal(doc.getPosition(0).line, 0);
        chai.assert.equal(doc.getPosition(0).character, 0);
        chai.assert.equal(doc.getPosition(doc.text.length).line, 2);
        chai.assert.equal(doc.getPosition(doc.text.length).character, 5);
    });
    it('getOffset', () => {
        const doc = new document_1.LspDocument({
            text: `Mdfsdf
dfsdfsd
dfdsf`, uri: 'foo', version: 0, languageId: 'FOO'
        });
        chai.assert.equal(doc.offsetAt({ line: 0, character: 4 }), 4);
        chai.assert.equal(doc.offsetAt({ line: 1, character: 4 }), 11);
        chai.assert.equal(doc.offsetAt({ line: 2, character: 4 }), 19);
    });
    it('getPosition with empty doc', () => {
        const doc = new document_1.LspDocument({
            text: '', uri: 'foo', version: 0, languageId: 'FOO'
        });
        chai.assert.equal(doc.getPosition(0).line, 0);
        chai.assert.equal(doc.getPosition(0).character, 0);
    });
});
//# sourceMappingURL=document.spec.js.map